import { createMemo, untrack } from 'solid-js';

// src/index.ts
function createJSXParser(options) {
  return { id: Symbol("") };
}
function createToken(parser, tokenData, render) {
  return (props) => {
    const token = render ? () => untrack(() => render(props)) : () => {
      return "";
    };
    token[parser.id] = true;
    token.data = tokenData ? tokenData(props) : props;
    return token;
  };
}
function getResolvedTokens(resolved, children, symbol, addElements) {
  if (typeof children === "function" && !children.length) {
    if (symbol in children)
      resolved.push(children);
    else
      getResolvedTokens(resolved, children(), symbol, addElements);
  } else if (Array.isArray(children))
    for (let i = 0; i < children.length; i++)
      getResolvedTokens(resolved, children[i], symbol, addElements);
  else if (addElements)
    resolved.push(children);
  else ;
  return resolved;
}
function resolveTokens(parser, fn, options) {
  const children = createMemo(fn);
  return createMemo(
    () => getResolvedTokens([], children(), parser.id, options?.includeJSXElements)
  );
}
function isToken(parser, value) {
  return typeof value === "function" && parser.id in value;
}

export { createJSXParser, createToken, isToken, resolveTokens };
